# Gamuform
Plugin pour générer des formulaires via saisies et des vues via gamutable semi automatiquement.

## Déclaration des objets
Il suffit de déclarer la `$GLOBALS['gamuform_objets']`
* soit simplement : `objet => nom de l'objet`
* soit plus détaillé :
```
objet => [
	'singulier' => 'nom_singulier',
	'pluriel'   => _T('prefix:nom_pluriel'),
	'creer'     => 'créer un nouvel xxx'
]
```
exemple :

```php
$GLOBALS['gamuform_objets'] =  array_merge(
	$GLOBALS['gamuform_objets'] ?? [],
	[
		'app_competition' => [
			'singulier' => 'competition',
			'pluriel'   => 'compétitions',
			'creer'     => 'Créer une nouvelle compétition'
		],
		'app_competiteur' => "compétiteurs",
	]
);
```


## Configuration des objets pour les saisies et pour l'affichage avec gamutable
Et de creer une fonction gamuform/mon_objet.php avec une fonction qui renvoie l'array des saisies
> il y a un exemple gamuform/exemple.php

## Page
Il suffit d'appeler cette page `spip.php?page=voir_gamuform`, en paramettre le nom de l'objet voulu `&objet=auteur` :
`spip.php?page=voir_gamuform&objet=auteur`
